# 2. 전체 시스템 개요(Overall description)

> - 제품 및 제품 요구사항에 영향을 미치는 일반적인 요인을 설명해야 한다.
> - 특정 요구사항을 설명하지 않고, 상세 요구사항(Specific requirements)에 관한 배경을 제공한다.

### 2.1. 제품 관점(Product perspective)

> - 제품을 관련된 다른 제품과의 관계를 중심으로 봐야 한다.
> - 제품이 독립적인 경우 명시되어야 하고, 더 큰 시스템의 구성 요소로 정의된다면 시스템의 요구사항을 소프트웨어의 기능과 관계시켜야 하며 시스템과 소프트웨어 사이의 인터페이스를 식별해야 한다.

### 2.1.1. 시스템 인터페이스(System interfaces)

> - 각 시스템 인터페이스를 나열한다.
> - 시스템 요구사항을 달성하기 위한 소프트웨어 기능과 시스템에 일치하는 인터페이스에 관해 설명한다.

본 시스템은 Cross-platform 소프트웨어이다. 다음과 같은 브라우저가 원활히 실행될 수 있는 시스템에서 동작 할 수 있다.
- Chrome 버전 61 이상
- Firefox 버전 60 이상
- Edge 버전 79 이상
- Safari 버전 11 이상
- Chrome for Android 버전 100 이상
- Samsung internet 버전 8.2 이상

### 2.1.2. 사용자 인터페이스(User interfaces)

> 1. 소프트웨어 제품과 사용자 간 인터페이스의 논리적 특성을 지정한다.
>    - 소프트웨어 요구사항을 충족하는 데 필요한 구성 특성(필요한 화면 형식, 페이지 또는 창 레이아웃, 보고서나 메뉴의 내용, 프로그래밍 가능한 기능 키의 사용 가능)을 포함
> 1. 시스템을 사용해야 하는 사람에게 최적화된 모든 측면을 설명한다.

사용자 인터페이스의 디자인은 Material Design이나 Metro Design 같이 플랫한 디자인을 추구한다.
인터페이스의 구성요소는 다음과 같다. 문서는 글뭉치의 집합입니다. 글뭉치는 문단이나 이미지, 영상, 링크 또는 csv등의 구조적 텍스트입니다. 글뭉치는 안의 내용에 따라 표시됩니다. 사용자는 글뭉치를 이리저리 원하는 장소에 배치 할 수 있습니다. 사용자는 글뭉치를 다른 웹 페이지에서 드래그엔드롭으로 끌어 올 수 있습니다. 사용자는 문서를 보이는 대로 웹 페이지로 출력 할 수 있습니다.


### 2.1.3. 하드웨어 인터페이스(Hardware interfaces)

> - 소프트웨어 제품과 시스템의 하드웨어 컴포넌트 사이에 각 인터페이스의 논리적 특성을 지정해야 한다.
> - 지원하는 기기의 종류와 지원 방법, 사용하는 프로토콜 등에 관한 내용을 다룬다.

### 2.1.4. 소프트웨어 인터페이스(Software interfaces)

> - 다른 필수 소프트웨어(데이터 관리 시스템, 운영체제, 수학 패키지)의 사용과 다른 시스템과의 인터페이스를 지정한다.
> - 각 소프트웨어 제품에 대해 제공되어야 하는 정보
>   1. Name
>   1. Mnemonic
>   1. Specification number
>   1. Version number
>   1. Source
> - 각 인터페이스에 대해 제공되어야 하는 정보
>   1. 소프트웨어와 인터페이스 하는 목적
>   1. 인터페이스에서 사용되는 메시지의 내용과 형식에 관한 정의
>      - 문서화된 인터페이스를 자세하게 설명할 필요는 없지만, 인터페이스를 정의하는 문서에 대한 참조가 필요하다.

### 2.1.5. 통신 인터페이스(Communications interfaces)

> - 로컬 네트워크 프로토콜과 같은 통신에 대한 다양한 인터페이스를 지정해야 한다.
### 2.1.6. 메모리 제약사항(Memory constraints)

> - 1차 및 2차 메모리에 적용 가능한 특성과 한계를 명시해야 한다.

### 2.1.7. 운영(Operations)

> - 지정해야 하는 운영 작업의 종류
>   1. 사용자 그룹의 다양한 운영 모드
>   1. Interactive한 작업 기간과 unattended한 작업의 기간
>   1. 데이터 처리 지원 기능
>   1. 백업 및 복구 동작
> >
> > - 사용자 인터페이스 항목의 일부로 지정되기도 한다.

### 2.1.8. 사이트 적용 요건(Site adaption requirements)

> - 특정 사이트, misson, 또는 동작 모드(grid value, safety, etc)에 특화된 어떤 데이터나 초기화 순서에 대한 요구사항을 정의한다.
> - 소프트웨어를 특정 설치에 알맞도록 수정해야 하는 사이트 또는 mission과 관련된 특징을 지정한다.

## 2.2. 제품 기능(Product functions)

> - 소프트웨어가 수행하는 주요 기능에 대한 요약을 제공한다.
>   - 필요한 기능의 요약은 상위 수준의 명세서로부터 가져올 수 있다.
> - 준수해야 하는 사항
>   1. 고객이나 다른 사람이 봤을 때 기능 목록을 보고 이해할 수 있도록 기능이 구성되어야 한다.
>   1. 텍스트 또는 그래픽을 통해 기능들 사이의 관계를 보여줄 수 있다.
>      - 여기에서 표현되는 다이어그램은 설계를 보여주기 위함이 아니라 변수 사이의 논리적 관계를 단순하게 보여주기 위한 것이다.

본 프로젝트의 결과물은 다음과 같은 기능을 수행한다.
- Scrap
    - Focus, Unfocus
    - 수정
    - 읽기
    - 삭제
    - 다른 것과 스왑
        - Alt 화살표로 스왑
    - LaTex 편집, 미리보기 띄워주기
    - 링크 타입
        - 미리보기 보여주기
        - 링크 캐시
    - git 히스토리 보여주기
    - LaTex 타입
    - 그림, 비디오
    - 워드, 한글 뷰어
    - 자동 완성
- Document
    - Scrap 얻어오기
    - 삭제
    - 태그 붙이기
    - 드래그 앤 드롭 업로드
    - 외부 변경 감지 자동 리로드
    - 공유
    - STUN, TURN 서버를 통한 편집
    - navigator
- File TreeView
    - 파일 삭제
    - 파일 다운로드
    - 파일 업로드
    - Document 오픈
    - 드래그앤드롭 파일 move
- Search
    - 문서 태그 검색
    - 문서 내용 검색
- Clipboard
    - 보기
    - 추가
    - 삭제
    - 클립보드 내용 바꾸기.
    - 드래그앤드롭 파일
- Management
    - login with session
    - Configure
    - 현지화(localization)
    - 테마
- 내부 플러그인
    - 샘플: 체스 형식 뷰어
- 브라우저 확장기능: 로그인이 필요한 곳을 위한 캐시된 웹사이트 제공하는

## 2.3. 사용자 특성(User characteristics)

사용자는 기본적인 GUI 조작을 할 줄 알며 인터넷 사용을 원활히 할 수 있고 기본적인 영어를 읽고 쓸 줄 알며, markdown을 작성할 수 있는 사용자로 한정한다. 일반적으로 13세 이상 65세 이하의 사람을 사용자로 가정한다.

> - 교육 수준, 경험, 기술적 전문 지식을 포함하여 제품의 대상이 되는 사용자의 일반적인 특성을 설명해야 한다.
> - 세부적인 요구사항을 기술하는 데 사용되어서는 안 되고, 세부 요구사항이 나중에 명시되는 이유로 제공되어야 한다.

## 2.4. 제약사항(Constraints)

> - 개발자의 선택을 제한할 모든 항목에 관한 일반적인 설명을 제공해야 한다.
> - 포함되는 내용
>   1. Regulatory plocies
>   1. Hardware limitations (e.g., signal timing requirements)
>   1. Interfaces to other applications
>   1. Parallel operation
>   1. Audit functions
>   1. Control functions
>   1. Higher-order language requirements
>   1. Signal handshake protocols(e.g., XON-XOFF, ACK-NACK)
>   1. Reliability requirements
>   1. Criticality of the application
>   1. Safety and security considerations
> 
- Docker 배포
- .env 설정
- 첫 로드후 로딩 0.5s 이내
- 동시 편집 이용자 5명 이내
- 1000 RPS 정도 버티기
- 
## 2.5. 가정 및 의존성(Assumptions and dependencies)

> - SRS에서 명시한 요구사항에 영향을 미치는 요소들을 나열해야 한다.
> - 이 요소들은 소프트웨어의 설계 제약사항이 아니라 SRS의 요구사항에 영향을 미칠 수 있는 변경 사항들이다.

## 2.6. 단계별 요구사항(Apportioning of requirements)

> - 시스템의 향후 버전으로 지연될 수 있는 요구사항을 식별해야 한다.